package net.awired.ajsl.core.system.enumeration;

import net.awired.ajsl.core.system.interfaces.Os;
import net.awired.ajsl.core.system.interfaces.OsType;
import net.awired.ajsl.core.system.interfaces.OsWindowsSeven;
import net.awired.ajsl.core.system.interfaces.OsWindowsVista;
import net.awired.ajsl.core.system.interfaces.OsWindowsXp;

public enum OsTypeList implements OsType<OsTypeList> {
    /** */
    XP(OsWindowsXp.class, "Windows XP", "xp", 5),
    /** */
    VISTA(OsWindowsVista.class, "Windows Vista", "vista", 6),
    /** */
    SEVEN(OsWindowsSeven.class, "Windows 7", "seven", 6.1),

    ;

    private final Class<? extends Os> osInterface;
    private final String              osName;
    private final String              shortname;
    private final double              version;

    private OsTypeList(Class<? extends Os> osInterface, String osName, String shortName, double version) {
        this.osInterface = osInterface;
        this.osName = osName;
        this.version = version;
        this.shortname = shortName;
    }

    public Class<? extends Os> getOsInterface() {
        return osInterface;
    }

    public String getOsName() {
        return osName;
    }

    public String getShortname() {
        return shortname;
    }

    public double getVersion() {
        return version;
    }

}
